import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataTlsPublicKeyConfig extends cdktf.TerraformMetaArguments {
    /**
    * PEM formatted string to use as the private key
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/tls/d/public_key#private_key_pem DataTlsPublicKey#private_key_pem}
    */
    readonly privateKeyPem: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/tls/d/public_key tls_public_key}
*/
export declare class DataTlsPublicKey extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "tls_public_key";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/tls/d/public_key tls_public_key} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataTlsPublicKeyConfig
    */
    constructor(scope: Construct, id: string, config: DataTlsPublicKeyConfig);
    get algorithm(): string;
    get id(): string;
    private _privateKeyPem?;
    get privateKeyPem(): string;
    set privateKeyPem(value: string);
    get privateKeyPemInput(): string | undefined;
    get publicKeyFingerprintMd5(): string;
    get publicKeyOpenssh(): string;
    get publicKeyPem(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
